/*
    ************************************************
    * SIMULAZIONE COLLEGAMENTI AEREI RETE MONDIALE *
    *           con Algoritmo di Dijkstra          *
		* REALIZZATO DA:                               *
		* Marco Sommella 50/482                        *
		* Giovanni Di Cecca 50/887                     *
		* Virginia Bellino 408/466                     *
		************************************************
*/

#include <limits.h>


/* Elementi dell'heap */
typedef struct heap_el
{
	int pos; /* indice posizione nell'array di vertici del grafo */
	int dist; /* distanza */
	int s; /* flag per Dijkstra */
} heap_el;


/* Rappresentazione di un heap */
typedef struct heap
{
	int size; /* dimensione dell'heap */
	heap_el *data; /* array di elementi dell'heap */
} heap;


/* Prototipi delle funzioni */
int left(int i);
int right(int i);
int p(int i);
void swap ( heap *q, int i, int j );
void Heapify ( heap *q, int i );
int EmptyHeap ( heap *q );
int GetMin ( heap *q );
int TrovaCorr (graph *G, heap *q, int start );
int *Dijkstra ( graph *G, int start );
void ControllaPercorsi ( graph *G );
